Unit Trid640;
Interface
         uses Dos;
         const
              vseg: word = $a000;
              sorh: word = 640;
         var page: byte;
         function SetGraphMode(m: word): boolean;
         procedure SetActivePage(p: byte);
         procedure PutPixel(x, y: integer; szin: byte);
Implementation
         function SetGraphMode(m: word): boolean;
         var regs: Registers;
         begin
              page := 0;
              regs.ax := m;
              Intr($10,regs);
              {asm; mov ax,m; int 10h; end;}
              SetGraphMode := Mem[0:$449] = m and $7f;
         end;
         procedure SetActivePage(p: byte);
         begin
              Port[$3d8] := p;
              {asm; mov al,p; mov dx,3d8h; out dx,al; end;}
              page := p;
         end;
         procedure PutPixel(x, y: integer; szin: byte);
         var offs: longint;
         begin
              offs := y * sorh + x;
              SetActivePage(offs shr 16);
              Mem[vseg:offs] := szin;
         end;
end.