Program CG04n6;
Uses Crt,Vesa,FastFile,BMP;

{ ! konvertljuk t az ICE2.IMG fjlt egy tmrtett, 256 szn BMP fjlra!
  ! [ALCHEMY -w1 -8 -o ICE2.IMG]
  - kapcsoljuk be a 320*200 felbontas 256 szn zemmdot!
  - nem tpizlt fjlknt tltsk be az ICE2.BMP kp
  - palettjt s bittrkpt!
  - vrjunk egy billenty lenyomsig!
  - kapcsoljuk vissza a karakteres zemmdot! }

var
   VMem: array[0..199,0..319] of byte absolute $a000:0;
   n,i,x,y,x0,y0: word;
   bf: TBITMAPFILEHEADER;
   bi: TBITMAPINFOHEADER;
   rgb: TRGBQUAD;
   b1,b2: byte;

procedure PlotXY(b: byte);
begin
     VMem[y,x] := b;
     x := x + 1;
end;

begin
     FastOpen('ICE2.BMP');
     FastLoad(seg(bf),ofs(bf),sizeof(bf));

     if bf.bfType = $4d42 then
     begin
          FastLoad(seg(bi),ofs(bi),sizeof(bi));

          SetGraphMode($13);

          case bi.biClrUsed of
               0  : case bi.biBitCount of
                         1 : n := 2;
                         4 : n := 16;
                         8 : n := 256;
                         24: n := 0;
                    end;
               else n := bi.biClrUsed;
          end;

          ByteSeek(bf.bfOffBits-n*sizeof(rgb));

          Port[$3c8] := 0;
          for i := 0 to n-1 do
          begin
               FastLoad(seg(rgb),ofs(rgb),sizeof(rgb));
               Port[$3c9] := rgb.rgbRed shr 2;
               Port[$3c9] := rgb.rgbGreen shr 2;
               Port[$3c9] := rgb.rgbBlue shr 2;
          end;

          x0 := (vm.vmWidth - bi.biWidth) shr 1;
          y0 := (vm.vmHeight - bi.biHeight) shr 1;

          case bi.biCompression of
               BI_RGB : for y := y0+bi.biHeight-1 downto y0 do
                            for x := x0 to x0+bi.biWidth-1 do
                                VMem[y,x] := ByteRead;
               BI_RLE8: begin
                             x := x0;
                             y := y0+bi.biHeight-1;
                             repeat
                                   b1 := ByteRead;
                                   b2 := ByteRead;
                                   case b1 of
                                        0  : case b2 of
                                                  0  : begin
                                                            x := x0;
                                                            y := y - 1;
                                                       end;
                                                  1  : ;
                                                  2  : begin
                                                            x := x + ByteRead;
                                                            y := y + ByteRead;
                                                       end;
                                                  else begin
                                                            for i := 1 to b2 do
                                                                PlotXY(ByteRead);
                                                            if b2 and 1 = 1 then
                                                               ByteRead;
                                                       end;
                                                  end;
                                        else for i := 1 to b1 do
                                                 PlotXY(b2);
                                   end;
                             until (b1 = 0) and (b2 = 1);
                        end;
               BI_RLE4: ;
          end;

          readkey;
          SetGraphMode(3);
     end;

     FastClose;
end.
