Program CG06n0;
Uses Crt,Vesa,FastFile;

type
    color = record
          r: byte;
          g: byte;
          b: byte;
    end;

var
   i,x,y: word;
   n: byte;
   pal: array[0..255] of color;

begin
     if paramcount <> 1 then halt(1);
     if not FastOpen(paramstr(1)) then halt(2);
     if not SetGraphMode($13) then halt(3);

     ByteSeek(54);

     Port[$3c8] := 0;
     for i := 0 to 255 do
     begin
          pal[i].b := ByteRead;
          pal[i].g := ByteRead;
          pal[i].r := ByteRead;
          n := ByteRead;
          Port[$3c9] := pal[i].r SHR 2;
          Port[$3c9] := pal[i].g SHR 2;
          Port[$3c9] := pal[i].b SHR 2;
     end;

     for y := 199 downto 0 do
         for x := 0 to 319 do
             PutPixel256(x,y,ByteRead);

     FastClose;
     readkey;
     SetGraphMode(3);
end.
