Program CG04n5;
Uses Crt,Vesa,FastFile,BMP;

{ ! konvertljuk t az ICE2.IMG fjlt egy 128 szn OS/2 BMP formtum fjlra,
  ! legyen 160*100 pixel felbonts [ALCHEMY -O -c128 -o -X160 -Y100 ICE2.IMG]
  - kapcsoljuk be a 320*200 felbontas 256 szn zemmdot!
  - nem tpizlt fjlknt tltsk be az ICE2.BMP kp
  - palettjt s bittrkpt!
  - vrjunk egy billenty lenyomsig!
  - kapcsoljuk vissza a karakteres zemmdot! }

var
   VMem: array[0..199,0..319] of byte absolute $a000:0;
   n,i,x,y,x0,y0: word;
   bf: TBITMAPFILEHEADER;
   bi: TBITMAPINFOHEADER;
   rgb: TRGBQUAD;

begin
     FastOpen('ICE2.BMP');
     FastLoad(seg(bf),ofs(bf),sizeof(bf));

     if bf.bfType = $4d42 then
     begin
          FastLoad(seg(bi),ofs(bi),sizeof(bi));

          SetGraphMode($13);

          case bi.biClrUsed of
               0  : case bi.biBitCount of
                         1 : n := 2;
                         4 : n := 16;
                         8 : n := 256;
                         24: n := 0;
                    end;
               else n := bi.biClrUsed;
          end;

          ByteSeek(bf.bfOffBits-n*sizeof(rgb));

          Port[$3c8] := 0;
          for i := 0 to n-1 do
          begin
               FastLoad(seg(rgb),ofs(rgb),sizeof(rgb));
               Port[$3c9] := rgb.rgbRed shr 2;
               Port[$3c9] := rgb.rgbGreen shr 2;
               Port[$3c9] := rgb.rgbBlue shr 2;
          end;

          x0 := (vm.vmWidth - bi.biWidth) shr 1;
          y0 := (vm.vmHeight - bi.biHeight) shr 1;
          for y := y0+bi.biHeight-1 downto y0 do
              for x := x0 to x0+bi.biWidth-1 do
                  VMem[y,x] := ByteRead;

          readkey;
          SetGraphMode(3);
     end;

     FastClose;
end.
