Program BMPVIEW;
Uses Crt,Vesa,FastFile,BMP;

var
   n,i,x,y,x0,y0: word;
   bf: TBITMAPFILEHEADER;
   bi: TBITMAPINFOHEADER;
   rgb: TRGBQUAD;
   b1,b2,r,g,b: byte;

begin
     writeln('BMPVIEW 1.0 by Kaproncai Tams');
     writeln('------------------------------');
     case paramcount of
          0:
          begin
               writeln('missing filename');
          end;
          1:
          begin
               if FastOpen(paramstr(1)) then
               begin
                    FastOpen(paramstr(1));
                    FastLoad(seg(bf),ofs(bf),sizeof(bf));

                    if bf.bfType = $4d42 then
                    begin
                         FastLoad(seg(bi),ofs(bi),sizeof(bi));

                         case bi.biWidth of
                              0..320:
                              begin
                                   if bi.biBitCount = 24 then
                                   begin
                                        i := $10f;
                                   end else
                                   begin
                                        i := $13;
                                   end;
                              end;
                              321..640:
                              begin
                                   if bi.biBitCount = 24 then
                                   begin
                                        i := $112;
                                   end else
                                   begin
                                        i := $101;
                                   end;
                              end;
                              641..800:
                              begin
                                   if bi.biBitCount = 24 then
                                   begin
                                        i := $115;
                                   end else
                                   begin
                                        i := $103;
                                   end;
                              end;
                         end;

                         if SetGraphMode(i) then
                         begin
                              if bi.biClrUsed = 0 then
                              begin
                                   case bi.biBitCount of
                                        1:
                                        begin
                                             n := 2;
                                        end;
                                        4:
                                        begin
                                             n := 16;
                                        end;
                                        8:
                                        begin
                                             n := 256;
                                        end;
                                        24:
                                        begin
                                             n := 0;
                                        end;
                                   end;
                              end else
                              begin
                                   n := bi.biClrUsed;
                              end;

                              ByteSeek(bf.bfOffBits-n*sizeof(rgb));

                              Port[$3c8] := 0;
                              for i := 1 to n do
                              begin
                                   FastLoad(seg(rgb),ofs(rgb),sizeof(rgb));
                                   Port[$3c9] := rgb.rgbRed shr 2;
                                   Port[$3c9] := rgb.rgbGreen shr 2;
                                   Port[$3c9] := rgb.rgbBlue shr 2;
                              end;

                              x0 := (vm.vmWidth - bi.biWidth) shr 1;
                              y0 := (vm.vmHeight - bi.biHeight) shr 1;
                              case bi.biCompression of
                                   BI_RGB:
                                   begin
                                        case bi.biBitCount of
                                             1:
                                             begin
                                             end;
                                             4:
                                             begin
                                             end;
                                             8:
                                             begin
                                                  for y := y0+bi.biHeight-1 downto y0 do
                                                  begin
                                                       for x := x0 to x0+bi.biWidth-1 do
                                                       begin
                                                            PutPixel256(x,y,ByteRead);
                                                       end;
                                                  end;
                                             end;
                                             24:
                                             begin
                                                  for y := y0+bi.biHeight-1 downto y0 do
                                                  begin
                                                       for x := x0 to x0+bi.biWidth-1 do
                                                       begin
                                                            b := ByteRead;
                                                            g := ByteRead;
                                                            r := ByteRead;
                                                            PutPixel16M(x,y,r,g,b);
                                                       end;
                                                  end;
                                             end;
                                        end;
                                   end;
                                   BI_RLE8:
                                   begin
                                        x := x0;
                                        y := y0+bi.biHeight-1;
                                        repeat
                                              b1 := ByteRead;
                                              b2 := ByteRead;
                                              if b1 = 0 then
                                              begin
                                                   case b2 of
                                                        0:
                                                        begin
                                                             x := x0;
                                                             y := y - 1;
                                                        end;
                                                        1:
                                                        begin
                                                        end;
                                                        2:
                                                        begin
                                                             x := x + ByteRead;
                                                             y := y + ByteRead;
                                                        end;
                                                        else
                                                        begin
                                                             for i := 1 to b2 do
                                                             begin
                                                                  PutPixel256(x,y,ByteRead);
                                                                  x := x + 1;
                                                             end;
                                                             if b2 and 1 = 1 then
                                                             begin
                                                                  ByteRead;
                                                             end;
                                                        end;
                                                   end;
                                              end else
                                              begin
                                                   for i := 1 to b1 do
                                                   begin
                                                        PutPixel256(x,y,b2);
                                                        x := x + 1;
                                                   end;
                                              end;
                                        until (b1 = 0) and (b2 = 1);
                                   end;
                                   BI_RLE4:
                                   begin
                                   end;
                              end;
                              readkey;
                              SetGraphMode(3);
                         end else
                         begin
                              writeln('video mode error');
                         end;
                    end else
                    begin
                         writeln('not valid BMP file');
                    end;
                    FastClose;
               end else
               begin
                    writeln('file not found');
               end;
          end;
          else
          begin
               writeln('Too many parameters');
          end;
     end;
end.
