Program CG06n2;
Uses Crt,Vesa,FastFile;

{ - Jelentsk meg a paramterknt tadott kpet a CG06n0.PAS segtsgvel!
  - vrjunk egy billenty lenyomsig!
  ! rtkeljk ki a lenyomott billentyt!
  !     1: fnyer cskkentse!
  !     2: fnyer nvelse!
  !     3: kontraszt cskkentse!
  !     4: kontraszt nvelse!
  !     5: fnyer alaprtkre lltsa!
  !     6: kontraszt alaprtkre lltsa!
  !     ESC: kilps!
  - kapcsoljuk vissza a karakteres zemmdot!                     [GULLS.BMP] }

type
    color = record
          r: byte;
          g: byte;
          b: byte;
    end;

const
     fenyero: real = 1;
     kontraszt: real = 1;

var
   i,x,y: word;
   n: byte;
   pal: array[0..255] of color;
   c: char;

function TuneColor(c:byte):byte;
var
   k: integer;
begin
     k := round((128 + (c - 128) * kontraszt) * fenyero);
     if k < 0 then
        k := 0
     else
         if k > 255 then
            k := 255;
     TuneColor := k;
end;

begin
     if paramcount <> 1 then halt(1);
     if not FastOpen(paramstr(1)) then halt(2);
     if not SetGraphMode($13) then halt(3);

     ByteSeek(54);

     Port[$3c8] := 0;
     for i := 0 to 255 do
     begin
          pal[i].b := ByteRead;
          pal[i].g := ByteRead;
          pal[i].r := ByteRead;
          n := ByteRead;
          Port[$3c9] := pal[i].r SHR 2;
          Port[$3c9] := pal[i].g SHR 2;
          Port[$3c9] := pal[i].b SHR 2;
     end;

     for y := 199 downto 0 do
         for x := 0 to 319 do
             PutPixel256(x,y,ByteRead);

     FastClose;

     repeat
           c := readkey;
           case c of
                '1':
                begin
                     if fenyero > 0 then
                        fenyero := fenyero - 0.01;
                end;
                '2':
                begin
                     fenyero := fenyero + 0.01;
                end;
                '3':
                begin
                     if kontraszt > 0 then
                        kontraszt := kontraszt - 0.01;
                end;
                '4':
                begin
                     kontraszt := kontraszt + 0.01;
                end;
                '5':
                begin
                     fenyero := 1;
                end;
                '6':
                begin
                     kontraszt := 1;
                end;
           end;
           Port[$3c8] := 0;
           for i := 0 to 255 do
           begin
                Port[$3c9] := TuneColor(pal[i].r) SHR 2;
                Port[$3c9] := TuneColor(pal[i].g) SHR 2;
                Port[$3c9] := TuneColor(pal[i].b) SHR 2;
           end;
     until c = #27;

     SetGraphMode(3);
end.
