Program CG07n3;
Uses Crt,Vesa,FastFile;

{ - Jelentsk meg a paramterknt tadott kpet a CG07n0.PAS segtsgvel!
  - vrjunk egy billenty lenyomsig!
  ! konvertljuk t a kpet fekete-fehrre vgssal!
  ! rtkeljk ki a lenyomott billentyt!
  !     1: vgskszb cskkentse!
  !     2: vgskszb nvelse!
  !     3: lltsuk be a vgskszb rtkt kzpre
  !     ESC: kilps!
  - kapcsoljuk vissza a karakteres zemmdot!                  [PORTRAIT.BMP] }

type
    color = record
          r: byte;
          g: byte;
          b: byte;
          n: word;
    end;

const
     kuszob: real = 128;
var
   i,x,y: word;
   n,min,max: byte;
   pal: array[0..255] of color;
   c: char;

function Center: real;
begin
     min := 255;
     max := 0;
     for i := 0 to 255 do
         if pal[i].n > 0 then
         begin
              n := round(0.299*pal[i].r + 0.587*pal[i].g + 0.114*pal[i].b);
              if n < min then
                 min := n;
              if n > max then
                 max := n;
         end;
     Center := min + (max - min) / 2;
end;

begin
     if paramcount <> 1 then halt(1);
     if not FastOpen(paramstr(1)) then halt(2);
     if not SetGraphMode($13) then halt(3);

     ByteSeek(54);

     Port[$3c8] := 0;
     for i := 0 to 255 do
     begin
          pal[i].b := ByteRead;
          pal[i].g := ByteRead;
          pal[i].r := ByteRead;
          n := ByteRead;
          Port[$3c9] := pal[i].r SHR 2;
          Port[$3c9] := pal[i].g SHR 2;
          Port[$3c9] := pal[i].b SHR 2;
          pal[i].n := 0;
     end;

     for y := 199 downto 0 do
         for x := 0 to 319 do
         begin
              n := ByteRead;
              PutPixel256(x,y,n);
              inc(pal[n].n);
         end;

     FastClose;

     repeat
           c := readkey;
           case c of
                '1':
                begin
                     if kuszob > 0 then
                        kuszob := kuszob - 1;
                end;
                '2':
                begin
                     if kuszob < 255 then
                        kuszob := kuszob + 1;
                end;
                '3':
                begin
                     kuszob := Center;
                end;
           end;
           Port[$3c8] := 0;
           for i := 0 to 255 do
           begin
                n := round(0.299*pal[i].r + 0.587*pal[i].g + 0.114*pal[i].b);
                if n < kuszob then
                begin
                     Port[$3c9] := 0;
                     Port[$3c9] := 0;
                     Port[$3c9] := 0;
                end else
                begin
                     Port[$3c9] := 63;
                     Port[$3c9] := 63;
                     Port[$3c9] := 63;
                end;
           end;
     until c = #27;

     SetGraphMode(3);
end.
