Program CG07n5;
Uses Crt,Vesa,FastFile;

{ - Jelentsk meg a paramterknt tadott kpet a CG07n0.PAS segtsgvel
  - fekete-fehrben a Bayer pattern dithering eljrssal!
  ! hasznljunk nagyobb felbontst (pl.640x400)!
  - vrjunk egy billenty lenyomsig!
  - kapcsoljuk vissza a karakteres zemmdot!                      [WALK.BMP] }

type
    color = record
          r: byte;
          g: byte;
          b: byte;
    end;

const
     bayer: array[0..7,0..7] of byte =
            (( 0,32, 8,40, 2,34,10,42),
	     (48,16,56,24,50,18,58,26),
	     (12,44, 4,36,14,46, 6,38),
	     (60,28,52,20,62,30,54,22),
	     ( 3,35,11,43, 1,33, 9,41),
	     (51,19,59,27,49,17,57,25),
	     (15,47, 7,39,13,45, 5,37),
	     (63,31,55,23,61,29,53,21));

var
   i,x,y: word;
   n: byte;
   pal: array[0..255] of color;

begin
     if paramcount <> 1 then halt(1);
     if not FastOpen(paramstr(1)) then halt(2);
     if not SetGraphMode($100) then halt(3);

     ByteSeek(54);

     Port[$3c8] := 0;
     for i := 0 to 255 do
     begin
          pal[i].b := ByteRead;
          pal[i].g := ByteRead;
          pal[i].r := ByteRead;
          n := ByteRead;
     end;

     for y := 199 downto 0 do
         for x := 0 to 319 do
         begin
              n := ByteRead;
              i := round(0.299*pal[n].r + 0.587*pal[n].g + 0.114*pal[n].b);
	      if i SHR 2 > bayer[(x AND 3) SHL 1,(y AND 3) SHL 1] then
                 PutPixel256(x SHL 1,y SHL 1,15)
              else
                  PutPixel256(x SHL 1,y SHL 1,0);
	      if i SHR 2 > bayer[(x AND 3) SHL 1 + 1,(y AND 3) SHL 1] then
                 PutPixel256(x SHL 1 + 1,y SHL 1,15)
              else
                  PutPixel256(x SHL 1 + 1,y SHL 1,0);
	      if i SHR 2 > bayer[(x AND 3) SHL 1,(y AND 3) SHL 1 + 1] then
                 PutPixel256(x SHL 1,y SHL 1 + 1,15)
              else
                  PutPixel256(x SHL 1,y SHL 1 + 1,0);
	      if i SHR 2 > bayer[(x AND 3) SHL 1 + 1,(y AND 3) SHL 1 + 1] then
                 PutPixel256(x SHL 1 + 1,y SHL 1 + 1,15)
              else
                  PutPixel256(x SHL 1 + 1,y SHL 1 + 1,0);
         end;

     FastClose;

     readkey;
     SetGraphMode(3);
end.
